﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using SampleAppUDP.Resources;
using System.Collections.ObjectModel;
using QtsUdp;

namespace SampleAppUDP
{
    public partial class MainPage : PhoneApplicationPage
    {
        private Service _udpSearchNas = new Service();
        private ObservableCollection<string> _naslist = new ObservableCollection<string>();
        private List<string> _tempNasList = new List<string>();
        // Constructor
        public MainPage()
        {
            InitializeComponent();
            this.Loaded += MainPage_Loaded;
        }

        void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            NASIPList.DataContext = _naslist;
        }

        private void buttonStartUDP_Click(object sender, RoutedEventArgs e)
        {
            NASIPList.Items.Clear();
            _tempNasList.Clear();
            ButtonStart.IsEnabled = false; //Only one usage of each socket address
            AsyncSearchResponseCallback responseCallback = new AsyncSearchResponseCallback(QTS_UDP_SearchNas_Response);
            _udpSearchNas.StartSearchNAS(this, responseCallback);
        }

        private void buttonStopUDP_Click(object sender, RoutedEventArgs e)
        {
            _udpSearchNas.StopSearchNAS();
            ButtonStart.IsEnabled = true;
        }

        void QTS_UDP_SearchNas_Response(ResponseCTX response)
        {
            if (_tempNasList.Contains(response.RemoteNASInfo.IPAddress) == true) //filter duplicate IP Address
                return;
            else
            {
                _tempNasList.Add(response.RemoteNASInfo.IPAddress);
                Dispatcher.BeginInvoke(() =>
                {
                    TextBlock Txtblock = new TextBlock();
                    Txtblock.Text = response.RemoteNASInfo.IPAddress + "\r\n";
                    NASIPList.Items.Add(Txtblock);
                });
            }
        }

    }
}