﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Threading;
using System.IO.IsolatedStorage;
using System.IO;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using System.Windows.Threading;
using QtsHttp.Comm;
using QtsHttp.FileStaion;

namespace PhoneApp1_7._5_Sample
{
    public partial class Page_LocalUploadFile : PhoneApplicationPage
    {
        App app = Application.Current as App;
        ObservableCollection<string> collection = new ObservableCollection<string>();
        CancellationTokenSource reqCancel = new CancellationTokenSource();
        DispatcherTimer timer;
        long uploadFileSize = 0; 

        public Page_LocalUploadFile()
        {

            //timer = new DispatcherTimer();
            //timer.Interval = new TimeSpan(0, 0, 5);
            //timer.Tick += new EventHandler(timer_Tick);
            //timer.Start();

            this.Loaded += Page_Choose_File_Loaded;
            InitializeComponent();
        }

        void timer_Tick(object sender, EventArgs e)
        {
            //try
            //{
            //    // These are TextBlock controls that are created in the page’s XAML file.      
            //    System.Diagnostics.Debug.WriteLine("Current: " + Microsoft.Phone.Info.DeviceStatus.ApplicationCurrentMemoryUsage.ToString());
            //    System.Diagnostics.Debug.WriteLine("Peak: " + Microsoft.Phone.Info.DeviceStatus.ApplicationPeakMemoryUsage.ToString());
            //}
            //catch (Exception ex)
            //{
            //    //MemoryTextBlock.Text = ex.Message;
            //}
        }

        void Page_Choose_File_Loaded(object sender, RoutedEventArgs e)
        {
            collection.Clear();
            IsolatedStorageFile isoFile;
            isoFile = IsolatedStorageFile.GetUserStoreForApplication();
            string[] isolatedFileName = isoFile.GetFileNames("Shared\\*");
            if (isolatedFileName.Length > 0)
            {
                for (int i = 0; i < isolatedFileName.Length; i++)
                {
                    collection.Add(isolatedFileName[i]);
                }
            }
            IsoStorageListBox.ItemsSource = collection;
        }



        protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (app.gFSObj == null)
            {
                MessageBox.Show("File Station Login Failed!");
                return;
            }
            base.OnNavigatedTo(e);
        }

        private void IsoStorageListBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ListBox source = (ListBox)sender;
            if (source.SelectedIndex == -1) // prevent execute this function twice at the same time
                return;

            if (MessageBox.Show("Upload file: " + source.SelectedItem.ToString(), "Confirm message", MessageBoxButton.OKCancel) == MessageBoxResult.Cancel)
            {
                source.SelectedIndex = -1;
                return;
            }
            else
            {
                string srcUploadPath = "Shared/" + source.SelectedItem.ToString();
                Upload_Start(srcUploadPath, app.gUploadDestPath);
            }
            source.SelectedIndex = -1;
        }
        
        async public void Upload_Start(string srcPath, string destPath)
        {

            string SrcFilePath = srcPath;

            int lastSlash = SrcFilePath.LastIndexOf("/");
            if (lastSlash == -1)
            {
                MessageBox.Show("Source file does not exist!");
                return;
            }
            string splitSrcFolderPath = SrcFilePath.Substring(0, lastSlash);
            string splitSrcFileName = SrcFilePath.Substring(lastSlash + 1, (SrcFilePath.Length - splitSrcFolderPath.Length) - 1);

            string uploadFileName = splitSrcFileName;
            string uploadDestPath = destPath;
            CancellationTokenSource reqCancellation = new CancellationTokenSource();
            SyncProgressBtyesCallback progress = new SyncProgressBtyesCallback(Upload_Progress);

            IsolatedStorageFileStream fileStream;
            try
            {
                fileStream = new IsolatedStorageFileStream(SrcFilePath, FileMode.Open, IsolatedStorageFile.GetUserStoreForApplication());
                uploadFileSize = fileStream.Length;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Source file does not exist!");
                return;
            }
            try
            {
                await app.gFSObj.UploadFileByPath(uploadFileName, uploadDestPath, 0, fileStream, progress, reqCancel);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }

        async void Upload_Progress(object sender, long totalbytes)
        {
            System.Diagnostics.Debug.WriteLine("Current: " + Microsoft.Phone.Info.DeviceStatus.ApplicationCurrentMemoryUsage.ToString());
            int nProgress = (int)(totalbytes * 100 / uploadFileSize);
            UploadProgress.Value = nProgress;
            System.Diagnostics.Debug.WriteLine("Progress: " + nProgress);
            if (nProgress == 100)
            {
                UploadProgress.Visibility = Visibility.Collapsed;
                UploadProgress.Value = 0;
                UploadProgress.Visibility = Visibility.Visible;

                MessageBox.Show("Upload Complete");
            }
        }
    }
}