﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using System.Threading;
using System.IO.IsolatedStorage;
using System.IO;
using System.Collections.ObjectModel;
using System.Threading.Tasks;
using QtsHttp.Comm;
using QtsHttp.FileStaion;


namespace PhoneApp1_7._5_Sample
{
    public class FolderFileImageConverter : System.Windows.Data.IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter,
            System.Globalization.CultureInfo culture)
        {
            bool isDir = (bool)value;
            if (isDir)
            {
                return new System.Windows.Media.Imaging.BitmapImage(new Uri("/folder.png", UriKind.Relative));
            }
            else
            {
                return new System.Windows.Media.Imaging.BitmapImage(new Uri("/file.png", UriKind.Relative));
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter,
            System.Globalization.CultureInfo culture)
        {
            return value;
        }
    }


    public partial class Page_Upload : PhoneApplicationPage
    {
        App app = Application.Current as App;
        ObservableCollection<FileEntry> collection = new ObservableCollection<FileEntry>();
        List<FileEntry> returnFileList = new List<FileEntry>();
        string previousPath = string.Empty;
        string currPath = string.Empty;
        CancellationTokenSource reqCancel = new CancellationTokenSource();

        public Page_Upload()
        {
            this.Loaded += Page_Upload_Loaded;
            InitializeComponent();
            FileListBox.ItemsSource = collection;
            
            InitDisplay();
        }

        void Page_Upload_Loaded(object sender, RoutedEventArgs e)
        {

        }

        async private void InitDisplay()
        {
            try
            {
                returnFileList = await app.gFSObj.GetShareFolderList(reqCancel);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            foreach (FileEntry iter in returnFileList)
            {
                collection.Add(iter);
            }

            returnFileList.Clear();
        }

        async private void OnSelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            ListBox source = (ListBox)sender;

            if (source.SelectedIndex == -1) // prevent execute this function twice at the same time
                return;

            if ((source.SelectedItem as FileEntry).IsDir != true)
            {
                return;
            }

            currPath = previousPath + "/" + (source.SelectedItem as FileEntry).FileName;

            collection.Clear();
            int returnFileCount = 0;
            try
            {
                returnFileCount = await app.gFSObj.GetFileListCount(currPath, reqCancel);
                returnFileList = await app.gFSObj.GetFileList(currPath, 0, returnFileCount, reqCancel);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }

            foreach (FileEntry iter in returnFileList)
            {
                collection.Add(iter);
            }

            previousPath = currPath;

            source.SelectedIndex = -1;

            return;
        }

        async protected override void OnNavigatedTo(System.Windows.Navigation.NavigationEventArgs e)
        {
            if (app.gFSObj == null)
            {
                MessageBox.Show("File Station Login Failed!");
                return;
            }
            base.OnNavigatedTo(e);

            if (previousPath != string.Empty)
            {
                collection.Clear();
                int returnFileCount = 0;
                try
                {
                    returnFileCount = await app.gFSObj.GetFileListCount(currPath, reqCancel);
                    returnFileList = await app.gFSObj.GetFileList(previousPath, 0, returnFileCount, reqCancel);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                foreach (FileEntry iter in returnFileList)
                {
                    collection.Add(iter);
                    System.Diagnostics.Debug.WriteLine(iter.FileName);
                }
            }
        }

        protected override void OnNavigatedFrom(System.Windows.Navigation.NavigationEventArgs e)
        {
            App app = Application.Current as App;
            base.OnNavigatedFrom(e);
        }

        async protected override void OnBackKeyPress(System.ComponentModel.CancelEventArgs e)
        {
            collection.Clear();
            returnFileList.Clear();

            int lastSlashPos = previousPath.LastIndexOf("/");

            if (lastSlashPos == -1) // under share_root, go back function menu
            {
                e.Cancel = false;
            }
            else if (lastSlashPos == 0) //under first level of share_root
            {
                e.Cancel = true;
                try
                {
                    returnFileList = await app.gFSObj.GetShareFolderList(reqCancel);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                previousPath = string.Empty;
            }
            else
            {
                e.Cancel = true;
                previousPath = previousPath.Substring(0, lastSlashPos);
                currPath = previousPath;
                lastSlashPos = previousPath.LastIndexOf("/");

                int returnFileCount = 0;
                try
                {
                    returnFileCount = await app.gFSObj.GetFileListCount(previousPath, reqCancel);
                    returnFileList = await app.gFSObj.GetFileList(previousPath, 0, returnFileCount, reqCancel);
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message);
                }
                //get title text
                string temp = previousPath;
                int tempLastSlashPos = temp.LastIndexOf("/");
                temp = temp.Remove(0, tempLastSlashPos);
            }

            FileListBox.SelectedIndex = -1;

            foreach (FileEntry iter in returnFileList)
            {
                collection.Add(iter);
            }

            FileListBox.ItemsSource = collection;
        }
    
        private void appbar_uploadbutton_Click(object sender, EventArgs e)
        {
            app.gUploadDestPath = currPath + "/";
            NavigationService.Navigate(new Uri("/Page_LocalUploadFile.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}